/*!
	\file	IAtlLayer.h
	\author	Abvent R&D Copyright (C) 2009
	\brief	The IAtlLayer interface.
*/

#ifndef	IAtlLayer_h
#define	IAtlLayer_h

#include "AvAtlTypes.h"

namespace AvAtl {

class	IAtlLayer
{

public:

	// Get the layer ID.
	virtual tUUID getId() const = 0;
	// Set the Layer ID.
	virtual void setId(tUUID inId) = 0;
	// Get the Layer Name
	virtual tUtf8 getName() const = 0;
	// Set the layer name.
	virtual void setName(tUtf8 inName) = 0;
	/// Get user interfaces private value
	virtual int						getUIValue() const = 0;
	/// Set user interfaces private value
	virtual void					setUIValue(int inValue) = 0;
	/// Put an XML representation of the background inside the father node.
	/** \retval the new node of the ambient.
		\retval NULL if an error occurs. */
	virtual XMLNodeRef putInXML(XMLNodeRef inFatherNode) const = 0;
	/// Initialize the background with the XML.
	/** \retval true intialization from XML succeed.
		\retval false an error occurs. */
	virtual bool initWithXML(XMLNodeRef inFatherNode) = 0;
	
protected:

	virtual ~IAtlLayer() {}
};

}

#endif
